﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DocumentProcessing
{
    class Program
    {
        // Listing 5-8. Stosowanie dynamicznie skonfigurowanego procesora
        static void Main(string[] args)
        {
            Document doc1 = new Document
            {
                Author = "Jan Kowalski",
                DocumentDate = new DateTime(2000, 01, 01),
                Text = "Czy przybyłem za wcześnie?"
            };
            Document doc2 = new Document
            {
                Author = "Wiesław Zatorski",
                DocumentDate = new DateTime(2001, 01, 01),
                Text = "Wierzcie mi! Nadchodzi nowe milenium."
            };

            DocumentProcessor processor = Configure();

            Console.WriteLine("Przetwarzanie dokumentu nr 1.");
            processor.Process(doc1);
            Console.WriteLine();
            Console.WriteLine("Przetwarzanie dokumentu nr 2.");
            processor.Process(doc2);

            Console.ReadKey();
        }

        // Listing 5-7. Konfigurowanie procesora dokumentów poprzez dodawanie procesów
        static DocumentProcessor Configure()
        {
            DocumentProcessor rc = new DocumentProcessor();
            rc.Processes.Add(new TranslateIntoFrenchProcess());
            rc.Processes.Add(new SpellcheckProcess());
            rc.Processes.Add(new RepaginateProcess());
            return rc;
        }
    }
}
